/* Copyright (C) 2006 - 2010 ScriptDev2 <https://scriptdev2.svn.sourceforge.net/>
 * This program is free software licensed under GPL version 2
 * Please see the included DOCS/LICENSE.TXT for more information */

#ifndef SC_GUARDAI_H
#define SC_GUARDAI_H

#define GENERIC_CREATURE_COOLDOWN 5000

struct MANGOS_DLL_DECL guardAI : public ScriptedAI
{
    public:
        explicit guardAI(Creature* pCreature);
        ~guardAI() {}

    uint32 GlobalCooldown;                                  //This variable acts like the global cooldown that players have (1.5 seconds)
    uint32 Bandage;
    uint32 Potion;
    uint32 Help;
    uint32 OffHand;
    uint32 ZoneAttackMsgTimer;
    bool yell;
    int _Aggro;
    float temp1;
    float temp2;
    Unit* enemy;
    Creature* Helper;

    void Reset();

    void Aggro(Unit *who);

    void JustDied(Unit *Killer);

    void DamageDeal(Unit *done_to, uint32 &damage);

    void DamageTaken(Unit *done_by, uint32 &damage);

    void UpdateAI(const uint32 diff);

    //common used for guards in main cities
    void DoReplyToTextEmote(uint32 em);

};

struct MANGOS_DLL_DECL guardAI_azuremyst : public guardAI
{
    guardAI_azuremyst(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_bluffwatcher : public guardAI
{
    guardAI_bluffwatcher(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_contested : public guardAI
{
    guardAI_contested(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_darnassus : public guardAI
{
    guardAI_darnassus(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_dunmorogh : public guardAI
{
    guardAI_dunmorogh(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_durotar : public guardAI
{
    guardAI_durotar(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_elwynnforest : public guardAI
{
    guardAI_elwynnforest(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_eversong : public guardAI
{
    guardAI_eversong(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_exodar : public guardAI
{
    guardAI_exodar(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_ironforge : public guardAI
{
    guardAI_ironforge(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_mulgore : public guardAI
{
    guardAI_mulgore(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_orgrimmar : public guardAI
{
    guardAI_orgrimmar(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_silvermoon : public guardAI
{
    guardAI_silvermoon(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_stormwind : public guardAI
{
    guardAI_stormwind(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_teldrassil : public guardAI
{
    guardAI_teldrassil(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_tirisfal : public guardAI
{
    guardAI_tirisfal(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

struct MANGOS_DLL_DECL guardAI_undercity : public guardAI
{
    guardAI_undercity(Creature* pCreature) : guardAI(pCreature) {}

    void ReceiveEmote(Player* pPlayer, uint32 text_emote);
};

#endif
